if($Pref::Server::TopPrint::NagClients $= "")
	$Pref::Server::TopPrint::NagClients = 0; //0 no nag 1 optional, chat message 2 required, messagebox

if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::RTBR_ServerControl_Hook)
		exec("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs");
	RTB_registerPref("Ask players to install mod?", "Top Prints", "$Pref::Server::TopPrint::NagClients", "list None 0 Chat_Message 1 Message_Box 2", "Script_TopPrint", 0, 0, 0);
}

registerOutputEvent ("GameConnection", "TopPrint", "string 200 156" TAB "int 1 10 3" TAB "bool" TAB "list NONE 0 CENTERPRINT 1 BOTTOMPRINT 2");
registerOutputEvent ("MiniGame", "TopPrintAll", "string 200 156" TAB "int 1 10 3" TAB "bool" TAB "list NONE 0 CENTERPRINT 1 BOTTOMPRINT 2");

function GameConnection::sendTopPrint (%client, %message, %time, %hideBar, %fallback)
{
	if(%client.TopPrintSuccess)
	{
		commandToClient (%client, 'TopPrint', %message, %time, %hideBar);
	} else {
		switch(%fallback)
		{
			case 1:
				commandToClient (%client, 'CenterPrint', %message, %time);
			case 2:
				commandToClient (%client, 'BottomPrint', "<just:center>" @ %message, %time, %hideBar);
			default:
		}
	}
}

function GameConnection::topPrint (%client, %message, %time, %hideBar, %fallback)
{
	if (isObject (%client))
	{
		%name = %client.getPlayerName ();
		%message = strreplace (%message, "%1", %name);
	}
	%client.sendTopPrint (%message, %time, %hideBar, %fallback);
}

function TopPrintAll (%message, %time, %hidebar, %fallback)
{
	%i = 0;
	while (%i < ClientGroup.getCount())
	{
		%cl = ClientGroup.getObject (%i);
		if (!%cl.isAIControlled ())
		{
			%cl.sendTopPrint(%message, %time, %hidebar, %fallback);
		}
		%i += 1;
	}
}

function MiniGameSO::TopPrintAll (%obj, %text, %time, %hideBar, %fallback, %client)
{
	if (%client !$= "")
	{
		if (%client.miniGame != %obj)
		{
			return;
		}
	}
	if (isObject (%client))
	{
		%name = %client.getPlayerName ();
		%text = strreplace (%text, "%1", %name);
	}
	%i = 0;
	while (%i < %obj.numMembers)
	{
		%cl = %obj.member[%i];
		%cl.sendTopPrint (%message, %time, %hideBar, %fallback);
		%i += 1;
	}
}

function clearTopPrint (%client)
{
	commandToClient (%client, 'ClearTopPrint');
}

function GameConnection::topPrintNag (%client)
{
	if (!%client.TopPrintSuccess) //raise this pref if your server absolutely requires the add-on
	{
		switch($Pref::Server::TopPrint::NagClients)
		{
			case 1:
				%client.ChatMessage("\c6This server uses Top Prints. Without this add-on you might not be able to see some information!");
			case 2:
				commandToClient (%client, 'MessageBoxOK', 'Required Add-On', 'This server uses Top Prints.<br>Without this add-on you will not be able to see important information!');
			default:
		}
	}
}

package topPrintServerPackage
{
	function gameConnection::autoAdminCheck(%client)
	{
		parent::autoAdminCheck(%client);

		commandToClient(%client, 'TopPrintHandshake');
		%client.schedule(1000,topPrintNag);
	}
};

deactivatePackage(topPrintServerPackage);
activatePackage(topPrintServerPackage);

function servercmdYesIHaveTopPrintYayAwesomeSuccess(%client)
{
	if(isObject(%client))
	{
		%client.TopPrintSuccess = 1;
	}
}

function servercmdnvmNoIDontHaveTopPrint(%client) //testing
{
	if(isObject(%client))
	{
		%client.TopPrintSuccess = 0;
	}
}

$OutputDescription_["Minigame", "TopPrintAll"] = "[message] [time] [hide] [fallback]" NL
																											"Displays a message at the bottom of this minigame's members screens." NL
																											"message (200): Self explanatory" NL
																											"time (0 - 10): Time for the message to disappear (0 never disappears)" NL
																											"hide: Hides the transparent black bar" NL
																											"fallback: Where to show the message for client without the mod installed";
$OutputDescription_["GameConnection", "TopPrint"] = "[message] [time] [hide] [fallback]" NL
																												"Displays a message at the bottom of this client's screen." NL
																												"message (200): Self explanatory" NL
																												"time (0 - 10): Time for the message to disappear (0 never disappears)" NL
																												"hide: Hides the transparent black bar" NL
																												"fallback: Where to show the message if the client doesn't have the mod installed";
																												
$TopPrint_Loaded = 1;